/**
 * Tells the Arcade collision solver to prefer certain contacts over others
 */
export var ContactSolveBias;
(function (ContactSolveBias) {
    ContactSolveBias["None"] = "none";
    ContactSolveBias["VerticalFirst"] = "vertical-first";
    ContactSolveBias["HorizontalFirst"] = "horizontal-first";
})(ContactSolveBias || (ContactSolveBias = {}));
/**
 * Vertical First contact solve bias Used by the [[ArcadeSolver]] to sort contacts
 */
export const VerticalFirst = {
    vertical: 1,
    horizontal: 2
};
/**
 * Horizontal First contact solve bias Used by the [[ArcadeSolver]] to sort contacts
 */
export const HorizontalFirst = {
    horizontal: 1,
    vertical: 2
};
/**
 * None value, [[ArcadeSolver]] sorts contacts using distance by default
 */
export const None = {
    horizontal: 0,
    vertical: 0
};
//# sourceMappingURL=ContactBias.js.map