import { Color } from '../../Color';
export class StateStack {
    constructor() {
        this.current = this._getDefaultState();
        this._states = [];
    }
    _getDefaultState() {
        return {
            opacity: 1,
            z: 0,
            tint: Color.White,
            material: null
        };
    }
    _cloneState() {
        return {
            opacity: this.current.opacity,
            z: this.current.z,
            tint: this.current.tint.clone(),
            material: this.current.material // TODO is this going to cause problems when cloning
        };
    }
    save() {
        this._states.push(this.current);
        this.current = this._cloneState();
    }
    restore() {
        this.current = this._states.pop();
    }
}
//# sourceMappingURL=state-stack.js.map