/**
 * Describes the different image filtering modes
 */
export var ImageFiltering;
(function (ImageFiltering) {
    /**
     * Pixel is useful when you do not want smoothing aka antialiasing applied to your graphics.
     *
     * Useful for Pixel art aesthetics.
     */
    ImageFiltering["Pixel"] = "Pixel";
    /**
     * Blended is useful when you have high resolution artwork and would like it blended and smoothed
     */
    ImageFiltering["Blended"] = "Blended";
})(ImageFiltering || (ImageFiltering = {}));
/**
 * Parse the image filtering attribute value, if it doesn't match returns null
 */
export function parseImageFiltering(val) {
    switch (val) {
        case ImageFiltering.Pixel:
            return ImageFiltering.Pixel;
        case ImageFiltering.Blended:
            return ImageFiltering.Blended;
        default:
            return null;
    }
}
//# sourceMappingURL=Filtering.js.map