import { Scene } from '../Scene';
import { GraphicsComponent } from './GraphicsComponent';
import { TransformComponent } from '../EntityComponentSystem/Components/TransformComponent';
import { Query, System, SystemType, World } from '../EntityComponentSystem';
export declare class GraphicsSystem extends System {
    world: World;
    readonly systemType = SystemType.Draw;
    priority: 0;
    private _token;
    private _graphicsContext;
    private _camera;
    private _engine;
    private _sortedTransforms;
    query: Query<typeof TransformComponent | typeof GraphicsComponent>;
    get sortedTransforms(): TransformComponent[];
    constructor(world: World);
    initialize(world: World, scene: Scene): void;
    private _zHasChanged;
    private _zIndexUpdate;
    preupdate(): void;
    update(delta: number): void;
    private _drawGraphicsComponent;
    private _targetInterpolationTransform;
    /**
     * This applies the current entity transform to the graphics context
     * @param entity
     */
    private _applyTransform;
}
