import { Component } from '../EntityComponentSystem/Component';
export class IsometricEntityComponent extends Component {
    /**
     * Specify the isometric map to use to position this entity's z-index
     * @param mapOrOptions
     */
    constructor(mapOrOptions) {
        super();
        /**
         * Vertical "height" in the isometric world
         */
        this.elevation = 0;
        this.columns = mapOrOptions.columns;
        this.rows = mapOrOptions.rows;
        this.tileWidth = mapOrOptions.tileWidth;
        this.tileHeight = mapOrOptions.tileHeight;
    }
}
//# sourceMappingURL=IsometricEntityComponent.js.map